#include "stdafx.h"
#include <GL/glut.h>
#include <stdlib.h>

/*  Initialize material property, light source, lighting model,
 *  and depth buffer.
 */

// Cross Product
//res.x = (u.y * v.z) - (u.z * v.y);
//res.y = (u.z * v.x) - (u.x * v.z);
//res.z = (u.x * v.y) - (u.y * v.x);

void init(void) 
{
   glEnable(GL_DEPTH_TEST);
}

void myCube(void)
{
	glPushMatrix();
	glTranslatef(-0.5, -0.5, -0.5);

	glBegin(GL_QUADS);

	   //Front side
	   glVertex3f(0.0, 0.0, 0.0);
	   glVertex3f(0.0, 1.0, 0.0);
	   glVertex3f(0.0, 1.0, 1.0);
	   glVertex3f(0.0, 0.0, 1.0);

	   //Right side
	   glVertex3f(1.0, 0.0, 0.0);
	   glVertex3f(1.0, 1.0, 0.0);
	   glVertex3f(1.0, 1.0, 1.0);
	   glVertex3f(1.0, 0.0, 1.0);

	   //Left side
	   glVertex3f(0.0, 0.0, 0.0);
	   glVertex3f(1.0, 0.0, 0.0);
	   glVertex3f(1.0, 0.0, 1.0);
	   glVertex3f(0.0, 0.0, 1.0);

	   //Top side
	   glVertex3f(0.0, 1.0, 0.0);
	   glVertex3f(1.0, 1.0, 0.0);
	   glVertex3f(1.0, 1.0, 1.0);
	   glVertex3f(0.0, 1.0, 1.0);

	   //Bottom side
	   glVertex3f(0.0, 0.0, 0.0);
	   glVertex3f(1.0, 0.0, 0.0);
	   glVertex3f(1.0, 1.0, 0.0);
	   glVertex3f(0.0, 1.0, 0.0);

	   //Back side
	   glVertex3f(0.0, 0.0, 1.0);
	   glVertex3f(1.0, 0.0, 1.0);
	   glVertex3f(1.0, 1.0, 1.0);
	   glVertex3f(0.0, 1.0, 1.0);

	glEnd();

	glPopMatrix();
}

void display(void)
{
   glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   gluLookAt(0.0, 0.0, 5.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);

   glColor3f(1.0, 1.0, 0.0);
   glutSolidSphere (1.0, 20, 16);

   /*glutSolidTeapot(0.5);
   glPolygonMode(GL_FRONT, GL_LINE);
   //glPolygonMode(GL_FRONT, GL_FILL);
   myCube();*/

   glFlush ();
}

void reshape (int w, int h)
{
   glViewport (0, 0, (GLsizei) w, (GLsizei) h);
   glMatrixMode (GL_PROJECTION);
   glLoadIdentity();
   gluPerspective(45.0, 1.0, 1.0, 50);
   
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
}

void keyboard(unsigned char key, int x, int y)
{
   switch (key) {
      case 27:
         exit(0);
         break;
   }
}

int main(int argc, char** argv)
{
   glutInit(&argc, argv);
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB | GLUT_DEPTH);
   glutInitWindowSize (500, 500); 
   glutInitWindowPosition (100, 100);
   glutCreateWindow (argv[0]);
   init ();
   glutDisplayFunc(display); 
   glutReshapeFunc(reshape);
   glutKeyboardFunc(keyboard);
   glutMainLoop();
   return 0;
}